/*
    $Id: test.h 1107 2007-04-16 23:59:13Z rvernica $

    Copyright (C) 2007 by The Regents of the University of California

    Redistribution of this file is permitted under the terms of the
    GNU Public License (GPL).

    Date: 05/04/2006
    Author: Rares Vernica <rvernica@ics.uci.edu>
*/

#ifndef _test_h_
#define _test_h_

#include "errorcorr.h"

class Test 
{
private:
  vector<string> *data;
  Clusters *clusters;
  const ErrorCorr *errorCorr;
  SimType thresholdMin, thresholdMax;
  bool doBuck;

  VectPredicate vectTest;

  float sumRelErr, sumRelErrCor;
  unsigned noRelErr, buck[20];

public:
  Test(vector<string>* dat, Clusters* clust, 
       SimType thresholdMin, SimType thresholdMax, bool doBuck = false);

  void create(const set<unsigned> &setQuery);
  void test();

  size_t size() const { return vectTest.size(); }
  void setErrorCorr(const ErrorCorr &errorCorr) { this->errorCorr = &errorCorr; }

  ostream& info(ostream &out) const;

  friend ostream& operator<<(ostream &out, const Test &t);
  friend istream& operator>>(istream &in, Test &t);
};

#endif

